Your search did not match any results.
Menu

Menu

Populate Menu with Data and Configure the Access to It

You can display Menu items from the items array or a dataSource. This demo contains an example of a data structure. If you use a dataSource, specify the displayExpr property.

To access the clicked item, use the onItemClick event handler function.

Configure the Menu

Use the orientation property to specify whether the Menu has horizontal or vertical orientation. Use the animation property to specify the type, delay, duration, and other options of show and hide menu actions.

Configure the Submenus

Clicking or a hovering a Menu item opens a drop-down menu that can contain several submenus. To specify the drop-down menu mode ("onClick" or "onHover"), use the showSubmenuMode property. If you need only to specify the first level of drop-down menus, use the showFirstSubmenuMode property.

If you want to hide the submenu when the mouse pointer leaves it, set the hideSubmenuOnMouseLeave property to true.

Customize Item Appearance

You can define specific fields in the item data objects to change the appearance of an item. For example, use the icon property to supply items with icons. Define an itemTemplate to customize item appearance.

Backend API
Copy to CodePen
Apply
Reset
$(() => { const dxMenu = $('#menu').dxMenu({ dataSource: menuData, hideSubmenuOnMouseLeave: false, displayExpr: 'name', onItemClick(data) { const item = data.itemData; if (item.price) { $('#product-details').removeClass('hidden'); $('#product-details > img').attr('src', item.icon); $('#product-details > .price').text(`$${item.price}`); $('#product-details > .name').text(item.name); } }, }).dxMenu('instance'); const showSubmenuModes = [{ name: 'onHover', delay: { show: 0, hide: 500 }, }, { name: 'onClick', delay: { show: 0, hide: 300 }, }]; $('#show-submenu-mode').dxSelectBox({ items: showSubmenuModes, value: showSubmenuModes[1], displayExpr: 'name', onValueChanged(data) { dxMenu.option('showFirstSubmenuMode', data.value); }, }); $('#orientation').dxSelectBox({ items: ['horizontal', 'vertical'], value: 'horizontal', onValueChanged(data) { dxMenu.option('orientation', data.value); }, }); $('#mouse-leave').dxCheckBox({ value: false, text: 'Hide Submenu on Mouse Leave', onValueChanged(data) { dxMenu.option('hideSubmenuOnMouseLeave', data.value); }, }); });
<!DOCTYPE html> <html xmlns="http://www.w3.org/1999/xhtml"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" /> <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script> <script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.2.6/css/dx.light.css" /> <script src="https://cdn3.devexpress.com/jslib/22.2.6/js/dx.all.js"></script> <script src="data.js"></script> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="index.js"></script> </head> <body class="dx-viewport"> <div class="demo-container"> <div class="form"> <div> <div class="label">Catalog:</div> <div id="menu"></div> <div id="product-details" class="hidden"> <img src="" /> <div class="name"></div> <div class="price"></div> </div> </div> <div class="options"> <div class="caption">Options</div> <div class="option"> <div>Show First Submenu Mode</div> <div id="show-submenu-mode"></div> </div> <div class="option"> <div>Orientation</div> <div id="orientation"></div> </div> <div class="option"> <div id="mouse-leave"></div> </div> </div> </div> </div> </body> </html>
.form { margin-left: 3px; } .form > div:first-child { margin-right: 320px; } .label { font-size: 22px; } #product-details { width: 400px; height: 400px; margin: 20px auto 0; } #product-details > img { height: 300px; width: 400px; } #product-details > .name { text-align: center; font-size: 20px; } #product-details > .price { text-align: center; font-size: 24px; } .dark #product-details > div { color: #f0f0f0; } .options { padding: 20px; position: absolute; bottom: 0; right: 0; width: 260px; top: 0; background-color: rgba(191, 191, 191, 0.15); } .caption { font-size: 18px; font-weight: 500; } .option { margin-top: 10px; } .hidden { visibility: hidden; }
const menuData = [{ id: '1', name: 'Video Players', items: [{ id: '1_1', name: 'HD Video Player', price: 220, icon: '../../../../images/products/1.png', }, { id: '1_2', name: 'SuperHD Video Player', icon: '../../../../images/products/2.png', price: 270, }], }, { id: '2', name: 'Televisions', items: [{ id: '2_1', name: 'SuperLCD 42', icon: '../../../../images/products/7.png', price: 1200, }, { id: '2_2', name: 'SuperLED 42', icon: '../../../../images/products/5.png', price: 1450, }, { id: '2_3', name: 'SuperLED 50', icon: '../../../../images/products/4.png', price: 1600, }, { id: '2_4', name: 'SuperLCD 55 (Not available)', icon: '../../../../images/products/6.png', price: 1350, disabled: true, }, { id: '2_5', name: 'SuperLCD 70', icon: '../../../../images/products/9.png', price: 4000, }], }, { id: '3', name: 'Monitors', items: [{ id: '3_1', name: '19"', items: [{ id: '3_1_1', name: 'DesktopLCD 19', icon: '../../../../images/products/10.png', price: 160, }], }, { id: '3_2', name: '21"', items: [{ id: '3_2_1', name: 'DesktopLCD 21', icon: '../../../../images/products/12.png', price: 170, }, { id: '3_2_2', name: 'DesktopLED 21', icon: '../../../../images/products/13.png', price: 175, }], }], }, { id: '4', name: 'Projectors', items: [{ id: '4_1', name: 'Projector Plus', icon: '../../../../images/products/14.png', price: 550, }, { id: '4_2', name: 'Projector PlusHD', icon: '../../../../images/products/15.png', price: 750, }], }];

import React from 'react';
import Menu from 'devextreme-react/menu';
import SelectBox from 'devextreme-react/select-box';
import CheckBox from 'devextreme-react/check-box';
import service from './data.js';
const orientations = ['horizontal', 'vertical'];
class App extends React.Component {
constructor(props) {
super(props);
this.products = service.getProducts();
this.showSubmenuModes = [{
name: 'onHover',
delay: { show: 0, hide: 500 },
}, {
name: 'onClick',
delay: { show: 0, hide: 300 },
}];
this.state = {
showFirstSubmenuModes: this.showSubmenuModes[1],
orientation: 'horizontal',
hideSubmenuOnMouseLeave: false,
currentProduct: null,
};
this.itemClick = this.itemClick.bind(this);
this.showSubmenuModeChanged = this.showSubmenuModeChanged.bind(this);
this.orientationChanged = this.orientationChanged.bind(this);
this.hideSubmenuOnMouseLeaveChanged = this.hideSubmenuOnMouseLeaveChanged.bind(this);
}
render() {
const {
showFirstSubmenuModes, orientation, hideSubmenuOnMouseLeave, currentProduct,
} = this.state;
return (
<div className="form">
<div>
<div className="label">Catalog:</div>
<Menu dataSource={this.products}
displayExpr="name"
showFirstSubmenuMode={showFirstSubmenuModes}
orientation={orientation}
hideSubmenuOnMouseLeave={hideSubmenuOnMouseLeave}
onItemClick={this.itemClick}
/>
{currentProduct
&& <div id="product-details">
<img src={currentProduct.icon} />
<div className="name">{currentProduct.name}</div>
<div className="price">{`$${currentProduct.price}`}</div>
</div>
}
</div>
<div className="options">
<div className="caption">Options</div>
<div className="option">
<div>Show First Submenu Mode</div>
<SelectBox
items={this.showSubmenuModes}
displayExpr="name"
value={showFirstSubmenuModes}
onValueChanged={this.showSubmenuModeChanged}
/>
</div>
<div className="option">
<div>Orientation</div>
<SelectBox
items={orientations}
value={orientation}
onValueChanged={this.orientationChanged}
/>
</div>
<div className="option">
<CheckBox
text="Hide Submenu on Mouse Leave"
value={hideSubmenuOnMouseLeave}
onValueChanged={this.hideSubmenuOnMouseLeaveChanged}
/>
</div>
</div>
</div>
);
}
itemClick(e) {
if (e.itemData.price) {
this.setState({
currentProduct: e.itemData,
});
}
}
showSubmenuModeChanged(e) {
this.setState({
showFirstSubmenuModes: e.value,
});
}
orientationChanged(e) {
this.setState({
orientation: e.value,
});
}
hideSubmenuOnMouseLeaveChanged(e) {
this.setState({
hideSubmenuOnMouseLeave: e.value,
});
}
}
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.2.3/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.js");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
.form {
margin-left: 3px;
}
.form > div:first-child {
margin-right: 320px;
}
.label {
font-size: 22px;
}
#product-details {
width: 400px;
height: 400px;
margin: 20px auto 0;
}
#product-details > img {
height: 300px;
width: 400px;
}
#product-details > .name {
text-align: center;
font-size: 20px;
}
#product-details > .price {
text-align: center;
font-size: 24px;
}
.dark #product-details > div {
color: #f0f0f0;
}
.options {
padding: 20px;
position: absolute;
bottom: 0;
right: 0;
width: 260px;
top: 0;
background-color: rgba(191, 191, 191, 0.15);
}
.caption {
font-size: 18px;
font-weight: 500;
}
.option {
margin-top: 10px;
}
.hidden {
visibility: hidden;
}
const products = [{
id: '1',
name: 'Video Players',
items: [{
id: '1_1',
name: 'HD Video Player',
price: 220,
icon: '../../../../images/products/1.png',
}, {
id: '1_2',
name: 'SuperHD Video Player',
icon: '../../../../images/products/2.png',
price: 270,
}],
}, {
id: '2',
name: 'Televisions',
items: [{
id: '2_1',
name: 'SuperLCD 42',
icon: '../../../../images/products/7.png',
price: 1200,
}, {
id: '2_2',
name: 'SuperLED 42',
icon: '../../../../images/products/5.png',
price: 1450,
}, {
id: '2_3',
name: 'SuperLED 50',
icon: '../../../../images/products/4.png',
price: 1600,
}, {
id: '2_4',
name: 'SuperLCD 55 (Not available)',
icon: '../../../../images/products/6.png',
price: 1350,
disabled: true,
}, {
id: '2_5',
name: 'SuperLCD 70',
icon: '../../../../images/products/9.png',
price: 4000,
}],
}, {
id: '3',
name: 'Monitors',
items: [{
id: '3_1',
name: '19"',
items: [{
id: '3_1_1',
name: 'DesktopLCD 19',
icon: '../../../../images/products/10.png',
price: 160,
}],
}, {
id: '3_2',
name: '21"',
items: [{
id: '3_2_1',
name: 'DesktopLCD 21',
icon: '../../../../images/products/12.png',
price: 170,
}, {
id: '3_2_2',
name: 'DesktopLED 21',
icon: '../../../../images/products/13.png',
price: 175,
}],
}],
}, {
id: '4',
name: 'Projectors',
items: [{
id: '4_1',
name: 'Projector Plus',
icon: '../../../../images/products/14.png',
price: 550,
}, {
id: '4_2',
name: 'Projector PlusHD',
icon: '../../../../images/products/15.png',
price: 750,
}],
}];
export default {
getProducts() {
return products;
},
};
window.config = {
transpiler: 'plugin-babel',
meta: {
'devextreme/localization.js': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
},
defaultExtension: 'js',
map: {
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types@15.8.1/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@22.2.3/cjs',
'devextreme-react': 'npm:devextreme-react@22.2.3',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.5.18/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.1.65/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.37/dist/dx-gantt.js',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.11',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat@7.4.11/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode@7.4.11/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class@7.4.11/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras@7.4.11/dist/inferno-extras.min.js',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.7.1/standalone.js',
'prettier/parser-html': 'npm:prettier@2.7.1/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.11/inferno/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
System.config(window.config);

<div class="form">
<div>
<div class="label">Catalog:</div>
<dx-menu
#menu
[dataSource]="products"
displayExpr="name"
[showFirstSubmenuMode]="showFirstSubmenuModes"
orientation="horizontal"
[hideSubmenuOnMouseLeave]="false"
(onItemClick)="itemClick($event)"
>
</dx-menu>
<div id="product-details" *ngIf="currentProduct">
<img src="{{ currentProduct.icon }}" />
<div class="name">{{ currentProduct.name }}</div>
<div class="price">{{ "$" + currentProduct.price }}</div>
</div>
</div>
<div class="options">
<div class="caption">Options</div>
<div class="option">
<div>Show First Submenu Mode</div>
<dx-select-box
[items]="showSubmenuModes"
displayExpr="name"
[(value)]="showFirstSubmenuModes"
></dx-select-box>
</div>
<div class="option">
<div>Orientation</div>
<dx-select-box
[items]="['horizontal', 'vertical']"
[(value)]="menu.orientation"
></dx-select-box>
</div>
<div class="option">
<dx-check-box
text="Hide Submenu on Mouse Leave"
[(value)]="menu.hideSubmenuOnMouseLeave"
></dx-check-box>
</div>
</div>
</div>
import { NgModule, Component, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { DxMenuModule, DxSelectBoxModule, DxCheckBoxModule } from 'devextreme-angular';
import { Product, Service } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
@Component({
selector: 'demo-app',
templateUrl: 'app/app.component.html',
styleUrls: ['app/app.component.css'],
providers: [Service],
})
export class AppComponent {
products: Product[];
showSubmenuModes: any;
showFirstSubmenuModes: any;
currentProduct: Product;
constructor(service: Service) {
this.products = service.getProducts();
this.showSubmenuModes = [{
name: 'onHover',
delay: { show: 0, hide: 500 },
}, {
name: 'onClick',
delay: { show: 0, hide: 300 },
}];
this.showFirstSubmenuModes = this.showSubmenuModes[1];
}
itemClick(data) {
const item = data.itemData;
if (item.price) {
this.currentProduct = item;
}
}
}
@NgModule({
imports: [
BrowserModule,
DxMenuModule,
DxSelectBoxModule,
DxCheckBoxModule,
],
declarations: [AppComponent],
bootstrap: [AppComponent],
})
export class AppModule { }
platformBrowserDynamic().bootstrapModule(AppModule);
::ng-deep .form {
margin-left: 3px;
}
::ng-deep .form > div:first-child {
margin-right: 320px;
}
::ng-deep .label {
font-size: 22px;
}
::ng-deep #product-details {
margin: 20px auto 0;
width: 400px;
height: 400px;
}
::ng-deep #product-details > img {
height: 300px;
width: 400px;
}
::ng-deep #product-details > .name {
text-align: center;
font-size: 20px;
}
::ng-deep #product-details > .price {
text-align: center;
font-size: 24px;
}
::ng-deep .dark #product-details > div {
color: #f0f0f0;
}
::ng-deep .options {
padding: 20px;
position: absolute;
bottom: 0;
right: 0;
width: 260px;
top: 0;
background-color: rgba(191, 191, 191, 0.15);
}
::ng-deep .caption {
font-size: 18px;
font-weight: 500;
}
::ng-deep .option {
margin-top: 10px;
}
::ng-deep .hidden {
visibility: hidden;
}
import { Injectable } from '@angular/core';
export class Product {
id: string;
name: string;
icon?: string;
price?: number;
disabled?: boolean;
items?: Product[];
}
const products: Product[] = [{
id: '1',
name: 'Video Players',
items: [{
id: '1_1',
name: 'HD Video Player',
price: 220,
icon: '../../../../images/products/1.png',
}, {
id: '1_2',
name: 'SuperHD Video Player',
icon: '../../../../images/products/2.png',
price: 270,
}],
}, {
id: '2',
name: 'Televisions',
items: [{
id: '2_1',
name: 'SuperLCD 42',
icon: '../../../../images/products/7.png',
price: 1200,
}, {
id: '2_2',
name: 'SuperLED 42',
icon: '../../../../images/products/5.png',
price: 1450,
}, {
id: '2_3',
name: 'SuperLED 50',
icon: '../../../../images/products/4.png',
price: 1600,
}, {
id: '2_4',
name: 'SuperLCD 55 (Not available)',
icon: '../../../../images/products/6.png',
price: 1350,
disabled: true,
}, {
id: '2_5',
name: 'SuperLCD 70',
icon: '../../../../images/products/9.png',
price: 4000,
}],
}, {
id: '3',
name: 'Monitors',
items: [{
id: '3_1',
name: '19"',
items: [{
id: '3_1_1',
name: 'DesktopLCD 19',
icon: '../../../../images/products/10.png',
price: 160,
}],
}, {
id: '3_2',
name: '21"',
items: [{
id: '3_2_1',
name: 'DesktopLCD 21',
icon: '../../../../images/products/12.png',
price: 170,
}, {
id: '3_2_2',
name: 'DesktopLED 21',
icon: '../../../../images/products/13.png',
price: 175,
}],
}],
}, {
id: '4',
name: 'Projectors',
items: [{
id: '4_1',
name: 'Projector Plus',
icon: '../../../../images/products/14.png',
price: 550,
}, {
id: '4_2',
name: 'Projector PlusHD',
icon: '../../../../images/products/15.png',
price: 750,
}],
}];
@Injectable()
export class Service {
getProducts(): Product[] {
return products;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/localization.js': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
},
map: {
'ts': 'npm:plugin-typescript@4.2.4/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'@angular/core': 'npm:@angular/core@12.2.16',
'@angular/platform-browser': 'npm:@angular/platform-browser@12.2.16',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic@12.2.16',
'@angular/forms': 'npm:@angular/forms@12.2.16',
'@angular/common': 'npm:@angular/common@12.2.16',
'@angular/compiler': 'npm:@angular/compiler@12.2.16',
'tslib': 'npm:tslib@2.3.1/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@22.2.3/cjs',
'devextreme/bundles/dx.all': 'npm:devextreme@22.2.3/bundles/dx.all.js',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.5.18/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.1.65',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.37',
'devextreme-angular': 'npm:devextreme-angular@22.2.3',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.11',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat@7.4.11/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode@7.4.11/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class@7.4.11/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras@7.4.11/dist/inferno-extras.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.7.1/standalone.js',
'prettier/parser-html': 'npm:prettier@2.7.1/parser-html.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.11/inferno/package.json',
'npm:@angular/*/package.json',
'npm:@angular/common@12.2.16/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devextreme-angular@22.2.3/*/package.json',
'npm:devextreme-angular@22.2.3/ui/*/package.json',
'npm:devextreme-angular@22.2.3/package.json',
'npm:devexpress-diagram@2.1.65/package.json',
'npm:devexpress-gantt@4.1.37/package.json',
],
};
System.config(window.config);
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.2.3/css/dx.light.css" />
<script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://unpkg.com/zone.js@0.12.0/dist/zone.js"></script>
<script src="https://unpkg.com/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>

<template>
<div class="form">
<div>
<div class="label">Catalog:</div>
<DxMenu
:data-source="products"
:show-first-submenu-mode="showFirstSubmenuModes"
:orientation="orientation"
:submenu-direction="submenuDirection"
:hide-submenu-on-mouse-leave="hideSubmenuOnMouseLeave"
display-expr="name"
@item-click="itemClick"
/>
<div
v-if="currentProduct"
id="product-details"
>
<img :src="currentProduct.icon">
<div class="name">{{ currentProduct.name }}</div>
<div class="price">{{ "$" + currentProduct.price }}</div>
</div>
</div>
<div class="options">
<div class="caption">Options</div>
<div class="option">
<div>Show First Submenu Mode</div>
<DxSelectBox
:items="showSubmenuModes"
v-model:value="showFirstSubmenuModes"
display-expr="name"
/>
</div>
<div class="option">
<div>Orientation</div>
<DxSelectBox
:items="['horizontal', 'vertical']"
v-model:value="orientation"
/>
</div>
<div class="option">
<div>Submenu Direction</div>
<DxSelectBox
:items="['auto', 'rightOrBottom', 'leftOrTop']"
v-model:value="submenuDirection"
/>
</div>
<div class="option">
<DxCheckBox
v-model:value="hideSubmenuOnMouseLeave"
text="Hide Submenu on Mouse Leave"
/>
</div>
</div>
</div>
</template>
<script>
import DxMenu from 'devextreme-vue/menu';
import DxCheckBox from 'devextreme-vue/check-box';
import DxSelectBox from 'devextreme-vue/select-box';
import service from './data.js';
export default {
components: {
DxMenu, DxSelectBox, DxCheckBox
},
data() {
const showSubmenuModes = [{
name: 'onHover',
delay: { show: 0, hide: 500 }
}, {
name: 'onClick',
delay: { show: 0, hide: 300 }
}];
return {
products: service.getProducts(),
showSubmenuModes,
showFirstSubmenuModes: showSubmenuModes[1],
orientation: 'horizontal',
submenuDirection: 'auto',
hideSubmenuOnMouseLeave: false,
currentProduct: null
};
},
methods: {
itemClick(e) {
if(e.itemData.price) {
this.currentProduct = e.itemData;
}
}
}
};
</script>
<style scoped>
.form {
margin-left: 3px;
}
.form > div:first-child {
margin-right: 320px;
}
.label {
font-size: 22px;
}
#product-details {
width: 400px;
height: 400px;
margin: 20px auto 0;
}
#product-details > img {
height: 300px;
width: 400px;
}
#product-details > .name {
text-align: center;
font-size: 20px;
}
#product-details > .price {
text-align: center;
font-size: 24px;
}
.dark #product-details > div {
color: #f0f0f0;
}
.options {
padding: 20px;
position: absolute;
bottom: 0;
right: 0;
width: 260px;
top: 0;
background-color: rgba(191, 191, 191, 0.15);
}
.caption {
font-size: 18px;
font-weight: 500;
}
.option {
margin-top: 10px;
}
.hidden {
visibility: hidden;
}
</style>
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.6/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.6/css/dx.light.css" />
<script src="https://unpkg.com/core-js@2.4.1/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import('./index.js');
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app">
</div>
</div>
</body>
</html>
const products = [{
id: '1',
name: 'Video Players',
items: [{
id: '1_1',
name: 'HD Video Player',
price: 220,
icon: '../../../../images/products/1.png'
}, {
id: '1_2',
name: 'SuperHD Video Player',
icon: '../../../../images/products/2.png',
price: 270
}]
}, {
id: '2',
name: 'Televisions',
items: [{
id: '2_1',
name: 'SuperLCD 42',
icon: '../../../../images/products/7.png',
price: 1200
}, {
id: '2_2',
name: 'SuperLED 42',
icon: '../../../../images/products/5.png',
price: 1450
}, {
id: '2_3',
name: 'SuperLED 50',
icon: '../../../../images/products/4.png',
price: 1600
}, {
id: '2_4',
name: 'SuperLCD 55 (Not available)',
icon: '../../../../images/products/6.png',
price: 1350,
disabled: true
}, {
id: '2_5',
name: 'SuperLCD 70',
icon: '../../../../images/products/9.png',
price: 4000
}]
}, {
id: '3',
name: 'Monitors',
items: [{
id: '3_1',
name: '19"',
items: [{
id: '3_1_1',
name: 'DesktopLCD 19',
icon: '../../../../images/products/10.png',
price: 160
}]
}, {
id: '3_2',
name: '21"',
items: [{
id: '3_2_1',
name: 'DesktopLCD 21',
icon: '../../../../images/products/12.png',
price: 170
}, {
id: '3_2_2',
name: 'DesktopLED 21',
icon: '../../../../images/products/13.png',
price: 175
}]
}]
}, {
id: '4',
name: 'Projectors',
items: [{
id: '4_1',
name: 'Projector Plus',
icon: '../../../../images/products/14.png',
price: 550
}, {
id: '4_2',
name: 'Projector PlusHD',
icon: '../../../../images/products/15.png',
price: 750
}]
}];
export default {
getProducts() {
return products;
}
};
System.config({
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader'
},
'devextreme/localization.js': {
"esModule": true
},
},
paths: {
'npm:': 'https://unpkg.com/'
},
map: {
'vue': 'npm:vue@3.0.0/dist/vue.esm-browser.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.0.15/index.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.6/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.26.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@20.2.6',
'devextreme-vue': 'npm:devextreme-vue@20.2.6',
'jszip': 'npm:jszip@3.6.0/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@0.10.3/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.0.18/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@2.0.24/dist/dx-gantt.js',
'preact': 'npm:preact@10.5.13/dist/preact.js',
'preact/hooks': 'npm:preact@10.5.13/hooks/dist/hooks.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js'
},
packages: {
'devextreme-vue': {
main: 'index.js'
},
'devextreme': {
defaultExtension: 'js'
},
'devextreme/events/utils': {
main: 'index'
},
'devextreme/events': {
main: 'index'
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js'
}
},
babelOptions: {
sourceMaps: false,
stage0: true
}
});